#!/usr/bin/python

if __name__ != "__main__":
	from ServerTab import *
else:
	from ArianneDebug import *

import string
from math import sqrt

def Startup():
	# Tell the arianne module what actions we will handle
	return "move"

def StringPos2List(pos):
	coordinates = string.split(pos)
	x = int(coordinates[0])
	y = int(coordinates[1])
	z = int(coordinates[2])
	return ([x, y, z])

def List2StringPos(tup):
	pos = str(tup[0]) + ' ' + str(tup[1]) + ' ' + str(tup[2])
	return pos

def Distance(pos1, pos2):
	delta_x = pos2[0] - pos1[0]
	delta_y = pos2[1] - pos1[1]
	delta_z = pos2[2] - pos1[2]

	dist = sqrt((delta_x * delta_x) +
	            (delta_y * delta_y) +
	            (delta_z * delta_z))

	return dist

def Move(origPos, destPos, turnDist):
	dist = Distance(origPos, destPos)
	if( dist <= turnDist ):
		return List2StringPos(destPos)
	
	delta_x = destPos[0] - origPos[0]
	delta_y = destPos[1] - origPos[1]
	delta_z = destPos[2] - origPos[2]

	turnDistX = (delta_x * turnDist) / dist
	turnDistY = (delta_y * turnDist) / dist
	turnDistZ = (delta_z * turnDist) / dist

	newPos = [ origPos[0] + turnDistX,
		   origPos[1] + turnDistY,
		   origPos[2] + turnDistZ ]
	
	newPos[0] = int(newPos[0])
	newPos[1] = int(newPos[1])
	newPos[2] = int(newPos[2])
	return List2StringPos(newPos)

def Execute(action):
	print "Move.py: Execute()"
	sourceID = action["source"]
	sourceOb = GetObject(sourceID)  # GetObject is from ServerTab
	if( sourceOb.has_key("position") == 0 ):
                print "Action COMPLETED FAIL"
		return complete_fail   # complete_fail is from ServerTab

	sourcePos = sourceOb["position"]

	if( action.has_key("destination") == 0 ):
                print "Action COMPLETED FAIL"
		return complete_fail

	destination = action["destination"]

	if( action.has_key("speed") == 0 ):
		speed = 10
	else:
		speed = int(action["speed"])

	newPos = Move(StringPos2List(sourcePos),
	              StringPos2List(destination),
		      speed)
	sourceOb["position"] = newPos
	Add(sourceOb)   # Add is from ServerTab
	if( newPos != destination ):
                print "Action IMCOMPLETED"
		return incomplete  # from ServerTab
	else:
                print "Action COMPLETED SUCCESS"
		return complete_success # from ServerTab
		

if __name__ == "__main__":
	ob1 = { "id": "1", "position": "1 1 1" }
	ob2 = { "id": "2", "position": "2 2 2" }
	ob3 = { "id": "3", "position": "3 3 3" }

	Add(ob1)
	Add(ob2)
	Add(ob3)
	
	Action = { "id" : "action", 
	           "type" : "move", 
		   "destination" : "100 1 100",
		   "source" : "1" }

	Execute(Action)
