#!/bin/sh

USER=`whoami`
if test "x${USER}" != "xroot";
then
    echo "This script must be run with root permission."
    exit 1
fi

ORG_DIR=`pwd`

# check for Python

FOUND_PYTHON=no

PYTHON_binchk="python python2 python2.2 python2.3"
for i in ${PYTHON_binchk};
do
    PYTHON_check=`$i -V 2>/dev/null; echo $?`
    if test ${PYTHON_check} -eq 0;
    then
        FOUND_PYTHON=yes
    fi

    if test "x${FOUND_PYTHON}" = "xyes";
    then
        PYTHON_VERSION=`$i -V 2>&1 | awk '{print $NF}'`
        if test `echo ${PYTHON_VERSION} | sed -e 's/\./ /g' | sed -e 's/[a-z]/ /g' | awk '{print $1$2}'` -ge 22;
        then
            FOUND_PYTHON=yes
            PYTHON_SHORT=`echo ${PYTHON_VERSION} | sed -e 's/\./ /g' | awk '{print $1"."$2}'`
            PYTHON_libchk="/usr/lib/python/config /usr/lib/python${PYTHON_SHORT}/config /usr/local/lib/python/config /usr/local/lib/python${PYTHON_SHORT}/config"
        else
            FOUND_PYTHON=no
        fi
    fi

    if test "x${FOUND_PYTHON}" = "xyes";
    then
        PYTHON=$i
        break
    fi
done

PYTHON_libdir=""
if test "x${FOUND_PYTHON}" = "xyes";
then
    for i in ${PYTHON_libchk};
    do
        if test -f "$i/libpython${PYTHON_SHORT}.a"
	then
            PYTHON_libdir=$i
            break
        fi
    done
fi

if test "x${PYTHON_libdir}" = "x";
then
    FOUND_PYTHON=no
fi

# Shared Object of libpython is required, so if it is not present, it is
# built here. It is assumed that a C/C++ compiler and binary archiver are
# installed.

if test "x${FOUND_PYTHON}" = "xyes";
then
    if !(test -f "$i/libpython${PYTHON_SHORT}.so")
    then
        cd $i
        mkdir .extract
        cd .extract
        ar xv ../libpython${PYTHON_SHORT}.a >/dev/null
        cd ..
        cc -shared -o libpython${PYTHON_SHORT}.so .extract/*.o
        rm -rf .extract
        mv libpython${PYTHON_SHORT}.so ../..
        ln -s ../../libpython${PYTHON_SHORT}.so libpython${PYTHON_SHORT}.so
        cd ${ORG_DIR}
        echo "$i/libpython${PYTHON_SHORT}.so is successfully created"
    else
        echo "$i/libpython${PYTHON_SHORT}.so already exists"
    fi
fi

if test "x${FOUND_PYTHON}" = "xno";
then
    echo "*** Python version 2.2 or later not found!"
fi

