/* $Id: NetworkManager.h,v 1.17 2002/04/26 18:03:39 doomster Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_NetworkManager_H
#define ARIANNE_NetworkManager_H


#include "Concurrent/Thread.h"
#include "Concurrent/Mutex.h"
#include "Manager/Manager.h"

#include "0_Network/GenericMessage.h"


/** This is a abstract base class of Network managers. */
class NetworkManager: public Manager
  {
  protected:
  /** This queue contains all the received messages in a FIFO way. */
  Queue<GenericMessage> incoming;

  public:
  NetworkManager();
  virtual ~NetworkManager();

  /** This sends a Generic Message to the connection given on generic message's ID */
  virtual void Add(GenericMessage *GenMes)=0;
  /** This recieves a generic message or blocks waiting. */
  virtual GenericMessage *Get()=0;
  /** Returns true if there is any message available. */
  virtual bool isAvailable() const=0;

  class NetManUnusedConException: public Exception
    {
    public:
    NetManUnusedConException(std::string const& where = "UNKNOWN"): Exception()
      {
      message = where + " - Error sending generic message on an unused connection.";
      }
    };

  };

#endif

