/* $Id: C2S_NLOGIN.cpp,v 1.15 2002/03/19 06:07:31 guidoj Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "1_Message/C2S_NLOGIN.h"
#include "Conversion/Conversion.h"
#include "DataTypes/Serializer.h"

Message_C2S_NLOGIN::Message_C2S_NLOGIN (): Message (), Data(), Info()
{
  sType = ARIANNE_NLOGIN;
  SubType = 0; /* Invalid */
  Data.clear(); /* Vector is empty */
  Info = "";
}

Message_C2S_NLOGIN::Message_C2S_NLOGIN(Uint8 Type): Message (), Data(), Info()
{
  sType = ARIANNE_NLOGIN;
  this->SubType = Type;
  Data.clear(); /* Vector is empty */
  Info = "";
}

Message_C2S_NLOGIN::Message_C2S_NLOGIN(Uint8 Type,
        std::vector<unsigned char> const& Data): Message (), Data(), Info()
{
  sType = ARIANNE_NLOGIN;
  this->SubType = Type;
  this->Data = Data;
  Info = "";
}

Message_C2S_NLOGIN::Message_C2S_NLOGIN(Uint8 Type,
        std::vector<unsigned char> const& Data,
        std::string const& Info): Message (), Data(), Info()
{
  sType = ARIANNE_NLOGIN;
  this->SubType = Type;
  this->Data = Data;
  this->Info = Info;
}

Message_C2S_NLOGIN::Message_C2S_NLOGIN(Uint8 Type,
        std::string const& Data): Message (), Data(), Info()
{
  std::vector<unsigned char> vect;
  StringToVector(Data, vect);

  sType = ARIANNE_NLOGIN;
  this->SubType = Type;
  this->Data = vect;
  Info = "";
}

Message_C2S_NLOGIN::Message_C2S_NLOGIN(Uint8 Type,
        std::string const& Data,
        std::string const& Info): Message (), Data(), Info()
{
  std::vector<unsigned char> vect;
  StringToVector(Data, vect);

  sType = ARIANNE_NLOGIN;
  this->SubType = Type;
  this->Data = vect;
  this->Info = Info;
}

Message_C2S_NLOGIN::~Message_C2S_NLOGIN ()
{
}

void
Message_C2S_NLOGIN::read(Serializer & s)
{
  s >> SubType;
  s >> Data;
  s >> Info;
}

void
Message_C2S_NLOGIN::write(Serializer & s) const
{
  s << SubType;
  s << Data;
  s << Info;
}

void
Message_C2S_NLOGIN::SetSubType(Uint8 Type)
{
  this->SubType = Type;
}

Uint8
Message_C2S_NLOGIN::GetSubType()
{
  return SubType;
}

void
Message_C2S_NLOGIN::SetData(std::vector<unsigned char> const& Data)
{
  this->Data = Data;
}

std::vector<unsigned char> const&
Message_C2S_NLOGIN::GetData()
{
  return Data;
}

void
Message_C2S_NLOGIN::SetInfo(std::string const& Info)
{
  this->Info = Info;
}

std::string const&
Message_C2S_NLOGIN::GetInfo()
{
  return Info;
}

Message *Message_C2S_NLOGIN::clone() const
{
  return new Message_C2S_NLOGIN(*this);
}
