/* $Id: C2S_NLOGIN.h,v 1.15 2002/03/19 06:07:32 guidoj Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_C2S_NLOGIN_h
#define ARIANNE_C2S_NLOGIN_h

#include "Types.h"
#include "Message.h"
#include <string>
#include <vector>

class Serializer;

/* Exactly the same interface */
#define Message_S2C_NLOGIN Message_C2S_NLOGIN

class Message_C2S_NLOGIN: public Message
  {
  Uint8 SubType;
  std::vector<unsigned char>Data;
  /** Last login info, only used on CONFIRMATION */
  std::string Info;

  public:
  Message_C2S_NLOGIN();
  virtual ~Message_C2S_NLOGIN();
  Message_C2S_NLOGIN(Uint8 Type);
  Message_C2S_NLOGIN(Uint8 Type, std::vector<unsigned char> const& Data);
  Message_C2S_NLOGIN(Uint8 Type, std::vector<unsigned char> const& Data,
                     std::string const& Info);
  Message_C2S_NLOGIN(Uint8 Type, std::string const& Data);
  Message_C2S_NLOGIN(Uint8 Type, std::string const& Data,
                     std::string const& Info);
  virtual void read(Serializer &s);
  virtual void write(Serializer &s) const;

  Message_C2S_NLOGIN(Message_C2S_NLOGIN const &b):
    Message(b),
    SubType(b.SubType),
    Data(b.Data),
    Info(b.Info)
    {
    }

  virtual Message *clone() const;

  void SetSubType(Uint8 Type);
  Uint8 GetSubType();
  void SetData(std::vector<unsigned char> const& Data);
  std::vector<unsigned char> const& GetData();
  void SetInfo(std::string const& Info);
  std::string const& GetInfo();
  };

#endif
