/* $Id: INTERNAL_POISON.h,v 1.14 2002/03/08 12:21:23 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_INTERNAL_POISON_h
#define ARIANNE_INTERNAL_POISON_h

#include "Types.h"
#include "Exceptions.h"
#include "Message.h"

class Serializer;

/** This is an internal message used for shutting down the server. */
class Message_INTERNAL_POISON: public Message
  {
  public:
  Message_INTERNAL_POISON():
    Message()
	{
	sType=ARIANNE_POISON;
	}
  virtual ~Message_INTERNAL_POISON()
    {
	  }

  virtual void read(Serializer &s)
    {
  	throw ClassNotSerializableException(__FILE_AND_LINE__);
	  }

  virtual void write(Serializer &s) const
    {
	  throw ClassNotSerializableException(__FILE_AND_LINE__);
  	}

  Message_INTERNAL_POISON(Message_INTERNAL_POISON const &b):
    Message(b)
	{
	}

  virtual Message *clone() const
    {
	return new Message_INTERNAL_POISON(*this);
	}
  };

#endif
