/* $Id: MessageManager.h,v 1.15 2002/03/08 12:21:24 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_MessageManager_H
#define ARIANNE_MessageManager_H

#include "Concurrent/Thread.h"
#include "Concurrent/Mutex.h"
#include "1_Message/Message.h"

#include "1_Message/MessagesTypes.h"

#include "Manager/Manager.h"


/** This is a abstract base class of Message managers. */
class MessageManager: public Manager
  {
  public:
  MessageManager():Manager() {};
  virtual ~MessageManager() {};

  /** This send a Message to the connection given on the message */
  virtual void Add(Message *GenMes)=0;
  /** This recieve a message or block waiting. */
  virtual Message *Get()=0;
  /** Returns true if there is any message available. */
  virtual bool isAvailable() const=0;

  virtual void loop()=0;

  class MesManUnMessageException: public Exception
    {
    public:
	MesManUnMessageException(std::string const& where = "UNKNOWN"): Exception()
	  {
	  message = where + " - Error recieving message: Unknown type.";
	  }
    };
  };

#endif
