/* $Id: S2C_PERCEPTION.cpp,v 1.17 2002/04/26 19:37:37 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "1_Message/S2C_PERCEPTION.h"
#include "DataTypes/Serializer.h"


Message_S2C_PERCEPTION::Message_S2C_PERCEPTION():
  Message()
  {
  sType=ARIANNE_PERCEPTION;
  }

Message_S2C_PERCEPTION::~Message_S2C_PERCEPTION()
  {
  }

void Message_S2C_PERCEPTION::read(Serializer &s)
  {
  s >> ObjectsModified;

  Uint32 size;
  s >> size;
  for(int i=0;i<(int)size;++i)
    {
	Object::ID id;
	s >> id;

	Object tmp;
	tmp.PutAttrib("id",id);

	ObjectsDeleted.push_back(tmp);
	}

  
  s >> perception;
  s >> uID;
  }

void Message_S2C_PERCEPTION::write(Serializer &s) const
  {
  s << ObjectsModified;

  /* We send only the ID of the deleted objects to save bandwidth */
  s << (Uint32) ObjectsDeleted.size();

  std::list<Object>::const_iterator last=ObjectsDeleted.end();
  for(std::list<Object>::const_iterator i=ObjectsDeleted.begin();i!=last;++i)
    {
	s << (*i).GetAttrib("id");
	}

  s << perception;
  s << uID;
  }

  
void Message_S2C_PERCEPTION::SetObjectsModified(std::list<Object> const& Objects)
  {
  this->ObjectsModified=Objects;
  }
  
std::list<Object> Message_S2C_PERCEPTION::GetObjectsModified() const
  {
  return ObjectsModified;
  }

void Message_S2C_PERCEPTION::SetObjectsDeleted(std::list<Object> const& Objects)
  {
  this->ObjectsDeleted=Objects;
  }
  
std::list<Object> Message_S2C_PERCEPTION::GetObjectsDeleted() const
  {
  return ObjectsDeleted;
  }
  
void Message_S2C_PERCEPTION::Setperception(Perception perception)
  {
  this->perception=perception;
  }
  
Perception Message_S2C_PERCEPTION::Getperception()
  {
  return perception;
  }
 
void Message_S2C_PERCEPTION::Settimestamp(Uint32 timestamp)
  {
  this->timestamp=timestamp;
  }

Uint32 Message_S2C_PERCEPTION::Gettimestamp() const
  {
  return timestamp;
  }

void Message_S2C_PERCEPTION::SetuID(Object::ID uID)
  {
  this->uID=uID;
  }
  
Object::ID Message_S2C_PERCEPTION::GetuID()
  {
  return uID;
  }

Message *Message_S2C_PERCEPTION::clone() const
  {
  return new Message_S2C_PERCEPTION(*this);
  }  
