/* $Id: S2C_PERCEPTION.h,v 1.17 2002/04/26 19:37:37 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_S2C_PERCEPTION_h
#define ARIANNE_S2C_PERCEPTION_h

#include "Types.h"
#include "Message.h"
#include "4_Object/Perception.h"
#include "4_Object/Object.h"

#include <list>

class Serializer;

class Message_S2C_PERCEPTION: public Message
  {
  std::list<Object> ObjectsModified;
  std::list<Object> ObjectsDeleted;
  Uint32 timestamp;
  Perception perception;
  Object::ID uID;

  public:
  Message_S2C_PERCEPTION();
  virtual ~Message_S2C_PERCEPTION();
  virtual void read(Serializer &s);
  virtual void write(Serializer &s) const;

  Message_S2C_PERCEPTION(Message_S2C_PERCEPTION const &b):
    Message(b),
    ObjectsModified(b.ObjectsModified),
    ObjectsDeleted(b.ObjectsDeleted),
    perception(b.perception),
    uID(b.uID)
	{
	}

  virtual Message *clone() const;

  void SetObjectsModified(std::list<Object> const& Objects);
  std::list<Object> GetObjectsModified() const;
  void SetObjectsDeleted(std::list<Object> const& Objects);
  std::list<Object> GetObjectsDeleted() const;
  void Setperception(Perception perception);
  Perception Getperception();
  void Settimestamp(Uint32 timestamp);
  Uint32 Gettimestamp() const;
  void SetuID(Object::ID uID);
  Object::ID GetuID();
  };

#endif
