/* $Id: S2C_SEND_VERSION.cpp,v 1.16 2002/03/11 22:43:39 guidoj Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "1_Message/S2C_SEND_VERSION.h"
#include "DataTypes/Serializer.h"


Message_S2C_SEND_VERSION::Message_S2C_SEND_VERSION():
  Message()
  {
  sType=ARIANNE_SEND_VERSION;
  }

Message_S2C_SEND_VERSION::~Message_S2C_SEND_VERSION()
  {
  }

void Message_S2C_SEND_VERSION::read(Serializer &s)
  {
  s >> Version >> MOTD;
  }

void Message_S2C_SEND_VERSION::write(Serializer &s) const
  {
  s << Version << MOTD;
  }
  
Uint32 Message_S2C_SEND_VERSION::GetVersion()
  {
  return Version;
  }

void Message_S2C_SEND_VERSION::SetMOTD(std::string const& motd)
  {
  MOTD=motd;
  }

std::string Message_S2C_SEND_VERSION::GetMOTD() const
  {
  return MOTD;
  }


Message *Message_S2C_SEND_VERSION::clone() const
  {
  return new Message_S2C_SEND_VERSION(*this);
  }
