/* $Id: S2C_SEND_VERSION.h,v 1.15 2002/03/08 12:21:24 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_S2C_SEND_VERSION_h
#define ARIANNE_S2C_SEND_VERSION_h

#include "Types.h"
#include "Define.h"
#include "Message.h"
#include <string>

class Serializer;

class Message_S2C_SEND_VERSION: public Message
  {
  Uint32 Version;
  std::string MOTD;
  
  public:
  Message_S2C_SEND_VERSION();
  virtual ~Message_S2C_SEND_VERSION();
  virtual void read(Serializer &s);
  virtual void write(Serializer &s) const;

  Message_S2C_SEND_VERSION(Message_S2C_SEND_VERSION const &b):
	Message(b), Version(ARIANNE_VERSION), MOTD(b.MOTD)
	{
	}

  virtual Message *clone() const;

  Uint32 GetVersion();

  void SetMOTD(std::string const& motd);
  std::string GetMOTD() const;
  };

#endif
