/* $Id: StatsStructs.cpp,v 1.2 2002/03/08 12:21:24 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "3_Manager/StatsStructs.h"


TemporalInfoLayer0::TemporalInfoLayer0 ():
NumberOfConnections (0),
ClientCrashes (0),
NetworkErrors (0),
BytesRecvSesion (0), BytesSentSesion (0), MaxPlayersReached (0)
{
}

TemporalInfoLayer0 &
  TemporalInfoLayer0::operator + (TemporalInfoLayer0 const &b)
{
  NumberOfConnections += b.NumberOfConnections;
  ClientCrashes += b.ClientCrashes;
  NetworkErrors += b.NetworkErrors;
  BytesRecvSesion += b.BytesRecvSesion;
  BytesSentSesion += b.BytesSentSesion;
  MaxPlayersReached += b.MaxPlayersReached;

  return *this;
}

TemporalInfoLayer0 & TemporalInfoLayer0::operator =
  (TemporalInfoLayer0 const &b)
{
  // Check for Self Assignment
  if(&b == this)
  {
     return *this; 
  }
  NumberOfConnections = b.NumberOfConnections;
  ClientCrashes = b.ClientCrashes;
  NetworkErrors = b.NetworkErrors;
  BytesRecvSesion = b.BytesRecvSesion;
  BytesSentSesion = b.BytesSentSesion;
  MaxPlayersReached = b.MaxPlayersReached;

  return *this;
}

void
TemporalInfoLayer0::Reset ()
{
  NumberOfConnections = 0;
  ClientCrashes = 0;
  NetworkErrors = 0;
  BytesRecvSesion = 0;
  BytesSentSesion = 0;
  MaxPlayersReached = 0;
}



TemporalInfoLayer1::TemporalInfoLayer1 ():
MessagesRecv (0), MessagesSent (0), InvalidMessages (0)
{
}

TemporalInfoLayer1 &
  TemporalInfoLayer1::operator + (TemporalInfoLayer1 const &b)
{
  MessagesRecv += b.MessagesRecv;
  MessagesSent += b.MessagesSent;
  InvalidMessages += b.InvalidMessages;

  return *this;
}

TemporalInfoLayer1 & TemporalInfoLayer1::operator =
  (TemporalInfoLayer1 const &b)
{
  // Check for Self Assignment
  if(&b == this)
  {
     return *this;
  }
  MessagesRecv = b.MessagesRecv;
  MessagesSent = b.MessagesSent;
  InvalidMessages = b.InvalidMessages;

  return *this;
}

void
TemporalInfoLayer1::Reset ()
{
  MessagesRecv = 0;
  MessagesSent = 0;
  InvalidMessages = 0;
}


TemporalInfoLayer2::TemporalInfoLayer2 ():
CommandsManaged (0), CommandsUnManaged (0)
{
}

TemporalInfoLayer2&
  TemporalInfoLayer2::operator + (TemporalInfoLayer2 const &b)
{
  CommandsManaged += b.CommandsManaged;
  CommandsUnManaged += b.CommandsUnManaged;

  return *this;
}

TemporalInfoLayer2 & TemporalInfoLayer2::operator =
  (TemporalInfoLayer2 const &b)
{
  // Check for Self Assignment
  if(&b == this)
  {
     return *this;
  }
  CommandsManaged = b.CommandsManaged;
  CommandsUnManaged = b.CommandsUnManaged;

  return *this;
}

void
TemporalInfoLayer2::Reset ()
{
  CommandsManaged = 0;
  CommandsUnManaged = 0;
}


TemporalInfoLayer3::TemporalInfoLayer3 ():
IncorrectVersion (0),
IncorrectLogin (0),
DualLogin (0),
OS_Win32 (0), OS_Linux (0), OS_BeOS (0), OS_MacOS (0), OS_Other (0)
{
}

TemporalInfoLayer3&
  TemporalInfoLayer3::operator + (TemporalInfoLayer3 const &b)
{
  IncorrectVersion += b.IncorrectVersion;
  IncorrectLogin += b.IncorrectLogin;
  DualLogin += b.DualLogin;
  OS_Win32 += b.OS_Win32;
  OS_Linux += b.OS_Linux;
  OS_BeOS += b.OS_BeOS;
  OS_MacOS += b.OS_MacOS;
  OS_Other += b.OS_Other;

  return *this;
}

TemporalInfoLayer3 & TemporalInfoLayer3::operator =
  (TemporalInfoLayer3 const &b)
{
  // Check for Self Assignment
  if(&b == this)
  {
     return *this;
  }

  IncorrectVersion = b.IncorrectVersion;
  IncorrectLogin = b.IncorrectLogin;
  DualLogin = b.DualLogin;
  OS_Win32 = b.OS_Win32;
  OS_Linux = b.OS_Linux;
  OS_BeOS = b.OS_BeOS;
  OS_MacOS = b.OS_MacOS;
  OS_Other = b.OS_Other;

  return *this;
}

void
TemporalInfoLayer3::Reset ()
{
  IncorrectVersion = 0;
  IncorrectLogin = 0;
  DualLogin = 0;
  OS_Win32 = 0;
  OS_Linux = 0;
  OS_BeOS = 0;
  OS_MacOS = 0;
  OS_Other = 0;
}



TemporalInfoLayer4::TemporalInfoLayer4 ():
NumberOfPlayers (0), NumberOfObjects (0)
{
}


TemporalInfoLayer4&
  TemporalInfoLayer4::operator + (TemporalInfoLayer4 const &b)
{
  NumberOfPlayers += b.NumberOfPlayers;
  NumberOfObjects += b.NumberOfObjects;

  return *this;
}

TemporalInfoLayer4 & TemporalInfoLayer4::operator =
  (TemporalInfoLayer4 const &b)
{
  // Check for Self Assignment
  if(&b == this)
  {
     return *this;
  }

  NumberOfPlayers = b.NumberOfPlayers;
  NumberOfObjects = b.NumberOfObjects;

  return *this;
}

void
TemporalInfoLayer4::Reset ()
{
  NumberOfPlayers = 0;
  NumberOfObjects = 0;
}


PermanentInfo::PermanentInfo ():
NumberOfPlayers (0),
Uptime (0),
StartTime (0),
BytesRecv (0),
BytesSend (0),
OS_Win32 (0),
OS_Linux (0), OS_BeOS (0), OS_MacOS (0), OS_Other (0), ServerCrashes (0)
{
}


PermanentInfo &PermanentInfo::operator + (PermanentInfo const &b)
{
  NumberOfPlayers += b.NumberOfPlayers;
  Uptime += b.Uptime;
  StartTime += b.StartTime;
  BytesRecv += b.BytesRecv;
  BytesSend += b.BytesSend;
  OS_Win32 += b.OS_Win32;
  OS_Linux += b.OS_Linux;
  OS_BeOS += b.OS_BeOS;
  OS_MacOS += b.OS_MacOS;
  OS_Other += b.OS_Other;
  ServerCrashes += b.ServerCrashes;

  return *this;
}

PermanentInfo & PermanentInfo::operator = (PermanentInfo const &b)
{
  // Check for Self Assignment
  if(&b == this)
  {
     return *this;
  }

  NumberOfPlayers = b.NumberOfPlayers;
  Uptime = b.Uptime;
  StartTime = b.StartTime;
  BytesRecv = b.BytesRecv;
  BytesSend = b.BytesSend;
  OS_Win32 = b.OS_Win32;
  OS_Linux = b.OS_Linux;
  OS_BeOS = b.OS_BeOS;
  OS_MacOS = b.OS_MacOS;
  OS_Other = b.OS_Other;
  ServerCrashes = b.ServerCrashes;

  return *this;
}
