/* $Id: StatsStructs.h,v 1.3 2002/03/08 12:21:24 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_STATS_STRUCTS_H
#define ARIANNE_STATS_STRUCTS_H

#include "Types.h"
#include <string>


#define TIME_BETWEEN_STATS_COMMANDS 10000

/** These are related to a period of time for Layer 0 */
struct TemporalInfoLayer0
  {
  Uint32 NumberOfConnections;  
  Uint32 ClientCrashes;
  Uint32 NetworkErrors;

  Uint32 BytesRecvSesion;
  Uint32 BytesSentSesion;

  Uint32 MaxPlayersReached;

  TemporalInfoLayer0();
  TemporalInfoLayer0& operator+(TemporalInfoLayer0 const& b);
  TemporalInfoLayer0& operator=(TemporalInfoLayer0 const& b);
  void Reset();
  };

/** These are related to a period of time for Layer 1 */
struct TemporalInfoLayer1
  {
  Uint32 MessagesRecv; 
  Uint32 MessagesSent;
  Uint32 InvalidMessages;

  TemporalInfoLayer1();
  TemporalInfoLayer1& operator+(TemporalInfoLayer1 const& b);
  TemporalInfoLayer1& operator=(TemporalInfoLayer1 const& b);
  void Reset();
  };

/** These are related to a period of time for Layer 2 */
struct TemporalInfoLayer2
  {
  Uint32 CommandsManaged;
  Uint32 CommandsUnManaged;

  TemporalInfoLayer2();
  TemporalInfoLayer2& operator+(TemporalInfoLayer2 const& b);
  TemporalInfoLayer2& operator=(TemporalInfoLayer2 const& b);
  void Reset();
  };

/** These are related to a period of time for Layer 3 */
struct TemporalInfoLayer3
  {
  Uint32 IncorrectVersion;
  Uint32 IncorrectLogin;
  Uint32 DualLogin;

  Uint32 OS_Win32;
  Uint32 OS_Linux;
  Uint32 OS_BeOS;
  Uint32 OS_MacOS;
  Uint32 OS_Other;

  TemporalInfoLayer3();
  TemporalInfoLayer3& operator+(TemporalInfoLayer3 const& b);
  TemporalInfoLayer3& operator=(TemporalInfoLayer3 const& b);
  void Reset();
  };

/** These are related to a period of time for Layer 4 */
struct TemporalInfoLayer4
  {
  Uint32 NumberOfPlayers;
  Uint32 NumberOfObjects;

  TemporalInfoLayer4();
  TemporalInfoLayer4& operator+(TemporalInfoLayer4 const& b);
  TemporalInfoLayer4& operator=(TemporalInfoLayer4 const& b);
  void Reset();
  };

/* These are available since the first time the server is boot */
struct PermanentInfo
  {
  Uint32 NumberOfPlayers;

  Uint32 Uptime;
  Uint32 StartTime;

  Uint32 BytesRecv;
  Uint32 BytesSend;

  Uint32 OS_Win32;
  Uint32 OS_Linux;
  Uint32 OS_BeOS;
  Uint32 OS_MacOS;
  Uint32 OS_Other;

  Uint32 ServerCrashes;

  PermanentInfo();
  PermanentInfo& operator+(PermanentInfo const& b);
  PermanentInfo& operator=(PermanentInfo const& b);
  };

/* This is the server description */
struct ServerInfo
  {
   std::string ServerName;
   std::string ServerNote;
   std::string ServerOS;
   std::string ServerIP;
   Uint32 MaxNumberPlayers;
  };

#endif
