/* $Id: Action.cpp,v 1.13 2002/04/05 14:00:43 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "Action.h"
#include <cstdio>

using namespace std;

int Action::action_id=0;


// Constructor
Action::Action(): Attributes() 
  {
  /* We add to the action an unique identification number. */
  // AddActionNumber();

  PutAttrib("id","action");
  PutAttrib("type","");
  }

Action::~Action()
  {
  }

Action::Type Action::GetType() const
  {
  return GetAttrib("type");
  }

Object::ID Action::GetSource()  const
  {
  return GetAttrib("source");
  }

Action& Action::operator=(Action const& a)
  {
  Attributes::operator=(a);

  return *this;
  }  

bool Action::Verify() const
  {
  try
    {
    if(GetAttrib("id")!="action") return false;
    GetAttrib("type");
    GetAttrib("source");
    }
  catch(AttributeNotFoundException &e)
    {
    return false;
    }

  return true;
  }

void Action::AddActionNumber()
  {
  char Buffer[20];
  sprintf(Buffer,"%i",action_id++);
  PutAttrib("action_id",Buffer);
  }

void Action::read(Serializer &s)
  {
  Attributes::read(s);
  }

void Action::write(Serializer &s) const
  {
  Attributes::write(s);
  }
