/* $Id: Action.h,v 1.21 2002/03/12 12:20:57 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef Action_H
#define Action_H	

#include "Types.h"

#include "Attributes.h"
#include "Object.h"

#include <string>
#include <list>

/** This class hold actions. */
class Action: public Attributes 
  {
  static int action_id;

  void AddActionNumber();

  public:
  typedef std::string Type;

  Action();
  ~Action();

  /** Returns the type value */
  Type GetType() const;    
  /** Returns the source value */
  Object::ID GetSource() const;

  Action& operator=(Action const& a);  
  bool Verify() const;  

  void read(Serializer &s);
  void write(Serializer &s) const;
  };

inline Serializer& operator<<(Serializer& s, std::list<Action> const& l)
  {
  s << (Uint32)l.size();

  std::list<Action>::const_iterator last = l.end();
  for(std::list<Action>::const_iterator it = l.begin(); it!=last; ++it)
    {
    s << (Action)(*it);
    }
  return s;
  }

inline Serializer& operator>>(Serializer& s, std::list<Action>& l)
  {
  Uint32 size;
  s >> size;
  l.clear();

  while(size--)
    {
    Action tmp;
    s >> tmp;
    l.push_back(tmp);
    }

  return s;
  }

inline Serializer& operator<<(Serializer& s, std::list<std::list<Action> > const& l)
  {
  s << (Uint32)l.size();

  std::list<std::list<Action> >::const_iterator last = l.end();
  for(std::list<std::list<Action> >::const_iterator it = l.begin(); it!=last; ++it)
    {
    s << (*it);
    }
  return s;
  }

inline Serializer& operator>>(Serializer& s, std::list<std::list<Action> >& l)
  {
  Uint32 size;
  s >> size;
  l.clear();

  while(size--)
    {
    std::list<Action> tmp;
    s >> tmp;
    l.push_back(tmp);
    }

  return s;
  }

#endif

