/* $Id: ObjectClassManager.h,v 1.5 2002/04/05 17:00:20 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __ObjectClassManager_h
#define __ObjectClassManager_h

#include "ObjectLoad.h"
#include "4_Object/Object.h"

/** The public interface class for accessing the Objects' template. */
class ObjectClassManager
  {
  std::map<ObjectClassInfo::Type,ObjectClassInfo> m_Classes;

  public:
  ObjectClassManager();
  ~ObjectClassManager();

  /** This load all the templates included in the config file */  
  void Load(std::string const& conf);

  /** This returns a copy of the Object Class information. */
  ObjectClassInfo Get(ObjectClassInfo::Type const& obj) const;
  Object Create(std::string object_type) const;

  class ObjectClassException: public Exception
    {
    protected:
    ObjectClassException(std::string const& where = "UNKNOWN"): Exception() {}
    };

  class ObjectClassFileNotFoundException: public ObjectClassException
    {
    public:
	  ObjectClassFileNotFoundException(std::string const& where = "UNKNOWN"): ObjectClassException()
	  {
	      message = where + " - Error: Object Class File not found";
	  }
    }; 

  class ObjectClassEntryNotFoundException: public ObjectClassException
    {
    public:
	  ObjectClassEntryNotFoundException(std::string const& where = "UNKNOWN"): ObjectClassException()
	  {
	      message = where + " - Error: Object Class Entry not found";
	  }
    }; 
  };

#endif

