/* $Id: Piece.h,v 1.18 2002/04/26 18:15:58 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_Piece_H
#define ARIANNE_Piece_H

#include "Object.h"
#include "Types.h"

#include <map>
#include <list>

class Serializer;

#include <iostream>

/** This is the basic structure of the World.
    It contains objects that are in a small area, limited by the 
	given parameters. */
class Piece
  {
  /** Size of the piece. */
  float x_init,y_init,x_end,y_end;

  /** Container for the object. */
  std::map<Object::ID, Object> m_Objects;

  Piece(Piece const&);
  Piece& operator=(Piece const&);

  friend class World;
  bool Load(std::istream &s, Object::ID &MaxUsedID);
  bool Save(std::ostream &s);

  public:
  Piece(Uint32 x_init=0, Uint32 y_init=0, Uint32 x_end=0, Uint32 y_end=0);
  ~Piece();

  /** Return true if the object is inside this piece, based on object position. */
  bool isInside(Object const& object);
  /** Get a copy of the object with object id id */
  Object Get(Object::ID const& id) const;
  /** Add a copy of the object to the world */
  void Add(Object const& object);
  /** Delete an object which id is is */
  void Del(Object::ID const& id);
  /** Delete the object*/
  void Del(Object const& object);
  /** Edit an object */
  void Edit(Object::ID const& id, std::string& Attrib, std::string& NewVal);

  /** Returns objects in the given cylinder. */
  std::list<Object> isInRange(std::string const& Center,Uint32 Distance);
  };

#endif

