/* $Id: Subtypes.cpp,v 1.24 2002/04/26 18:15:58 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Subtypes.h"
#include "Conversion/StringTool.h"

using namespace std;

#include <cmath>

Position::Position(std::string const& b)
  {
  vector<string> split = Split(b);
  float x = atof(split[0].c_str());
  float y = atof(split[1].c_str());
  float z = atof(split[2].c_str());

  m_x = x;
  m_y = y;
  m_z = z;
  }

Position& Position::operator=(std::string const& b)
  {
  vector<string> split = Split(b);
  float x = atof(split[0].c_str());
  float y = atof(split[1].c_str());
  float z = atof(split[2].c_str());

  m_x = x;
  m_y = y;
  m_z = z;

  return *this;
  }


float Position::Distance(Position const &b) const
  {
  float dx = m_x - b.m_x;
  float dy = m_y - b.m_y;
  float dz = m_z - b.m_z;
  return (float)sqrt((dx * dx) + (dy * dy) + (dz * dz));
  }

bool Position::operator==(Position const& b) const
  {
  return ((m_x == b.m_x) &&
          (m_y == b.m_y) &&
          (m_z == b.m_z));
  }


Volume::Volume(std::string const& b)
  {
  vector<string> split = Split(b);
  float a1 = atof(split[0].c_str());
  float b1 = atof(split[1].c_str());

  m_a = a1;
  m_b = b1;
  }

Volume& Volume::operator=(std::string const& b)
  {
  vector<string> split = Split(b);
  float a1 = atof(split[0].c_str());
  float b1 = atof(split[1].c_str());

  m_a = a1;
  m_b = b1;

  return *this;
  }

bool Volume::operator==(Volume const& b) const
  {
  return ((m_a == b.m_a) &&
	  (m_b == b.m_b));
  }

Orientation::Orientation(std::string const& b)
  {
  vector<string> split = Split(b);
  float x = atof(split[0].c_str());
  float y = atof(split[1].c_str());
  float z = atof(split[2].c_str());

  m_yaw = x;
  m_roll = y;
  m_pitch = z;
  }

Orientation& Orientation::operator=(std::string const& b)
  {
  vector<string> split = Split(b);
  float x = atof(split[0].c_str());
  float y = atof(split[1].c_str());
  float z = atof(split[2].c_str());

  m_yaw = x;
  m_roll = y;
  m_pitch = z;

  return *this;
  }

bool Orientation::operator==(Orientation const& b) const
  {
  return ((m_yaw   == b.m_yaw) &&
          (m_roll  == b.m_roll) &&
          (m_pitch == b.m_pitch));
  }

