/* $Id: Subtypes.h,v 1.20 2002/04/26 18:15:58 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef Arianne_ObjectSubTypes_H
#define Arianne_ObjectSubTypes_H

#include "Types.h"
#include <string>

/** Structure to store coordinates in a 3D euclidean space */
struct Position
  {
  /** These are the coordinates of the object in a 3D space. */
  float m_x,m_y,m_z;

  Position(std::string const& b);
  Position& operator=(std::string const& b);
  float Distance(Position const& b) const;
  bool operator==(Position const& b) const;
  };

struct Volume
  {
  /** These describe the a cylinder */
  float m_a; /* Height */
  float m_b; /* Radious */

  Volume(std::string const& b);
  Volume& operator=(std::string const& b);
  bool operator==(Volume const& b) const;
  };

struct Orientation
  {
  /** Angles for a 3D space. */
  float m_yaw,m_roll,m_pitch;

  Orientation(std::string const& b);
  Orientation& operator=(std::string const& b);
  bool operator==(Orientation const& b) const;
  };

#endif
