/* $Id: World.h,v 1.18 2002/03/08 12:21:24 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_World_H 
#define ARIANNE_World_H

#include "4_Object/Object.h"
#include "4_Object/Piece.h"

/*TODO: Now it only host a single piece, it should be able to host lots of them.
        We need to create the structure that best approach our needs. */

#include <iostream>

/** The World class contains several Pieces. */
class World
  {
  public: typedef std::string ID;

  private:
  /** Unique World Identificator */
  World::ID id;

  /** World Name */ 
  std::string name;

  /** Container for pieces. */
  Piece m_mappiece;

  // not copyable
  World(World const& b);
  // not assignable
  World& operator=(World const& b);

  friend class WorldManager;
  bool Load(std::istream& s,Object::ID &MaxUsedID);
  bool Save(std::ostream& s);

  public:  
  World();
  ~World();

  /** Get a copy of the object with object id id */
  Object Get(Object::ID const& id) const;
  /** Add a copy of the object to the world */
  void Add(Object const& object);
  /** Delete an object which id is is */
  void Del(Object::ID const &id);
  /** Delete the object*/
  void Del(Object const& object);

  /** Returns objects in the given cylinder. */
  std::list<Object> isInRange(std::string const& Center,Uint32 Distance);
  };

#endif




