/* $Id: Mutex.cpp,v 1.13 2001/12/23 17:28:39 arianne_rpg Exp $ */
/***************************************************************************
                          mutex.cpp  -  description
                             -------------------
    begin                : Sat Jun 24 2000
    copyright            : (C) 2000 by Ulrich Eckhardt
    email                : Doomster@knuut.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This a mutex implementation class.
***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Mutex.h"
#include "Exceptions.h"
Mutex::Mutex(bool locked):
  m_SDLMutex(SDL_CreateMutex())
  {
  if(!m_SDLMutex)
    throw MutexAllocException(__FILE_AND_LINE__);

  if(locked)
    {
	Lock();
	}
  }

Mutex::~Mutex()
  {
  SDL_DestroyMutex(m_SDLMutex);
  }

void Mutex::Lock()
  {
  if(SDL_LockMutex(m_SDLMutex)<0)
    {
	throw MutexLockException(__FILE_AND_LINE__);
	}
  }

void Mutex::Unlock()
  {
  if(SDL_UnlockMutex(m_SDLMutex))
    {
	throw MutexUnlockException(__FILE_AND_LINE__);
	}
  }
