/* $Id: Semaphore.cpp,v 1.13 2001/12/23 17:28:39 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Semaphore.h"
#include "Mutex.h"
#include "Exceptions.h"

Semaphore::Semaphore(Uint8 count):
  m_SDLSemaphore(SDL_CreateSemaphore(count))
  {
  if(!m_SDLSemaphore)
      throw SemaphoreAllocException(__FILE_AND_LINE__);
  }

Semaphore::~Semaphore()
  {
  SDL_DestroySemaphore(m_SDLSemaphore);
  }

  
void Semaphore::Wait()
  {
  if(SDL_SemWait(m_SDLSemaphore)<0)
    {
	throw SemaphoreWaitException(__FILE_AND_LINE__);
	}
  }

void Semaphore::Post()
  {
  if(SDL_SemPost(m_SDLSemaphore)<0)
    {
	throw SemaphorePostException(__FILE_AND_LINE__);
	}
  }

