/* $Id: Bzip2Compress.cpp,v 1.4 2002/04/05 14:00:44 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "Bzip2Compress.h"

#define BUFFER_SIZE 1024
using namespace std;

void Bzip2Compress::Begin()
  {
  incoming.next_in = 0;
  incoming.avail_in = 0;

  incoming.bzalloc = 0;
  incoming.bzfree = 0;
  incoming.opaque = 0;
  
  outgoing.bzalloc = 0;
  outgoing.bzfree = 0;
  outgoing.opaque = 0;
  
  BZ2_bzCompressInit(&outgoing,1,0,0);
  BZ2_bzDecompressInit(&incoming,0,0);
  }
  
void Bzip2Compress::End()
  {
  BZ2_bzCompressEnd(&outgoing);
  BZ2_bzDecompressEnd(&incoming);
  }
    
vector<Uint8> Bzip2Compress::Encode(vector<Uint8> const& data)
  {   
  vector<Uint8> out;
  int status;

  Uint8 Buffer[BUFFER_SIZE];
  
  //TODO: Is this correct or should we dump the vector to a buffer?
  outgoing.next_in=(char *)&data[0];
  outgoing.avail_in=data.size();

  do 
    {       
	outgoing.next_out=(char *)Buffer;
	outgoing.avail_out=BUFFER_SIZE;	  
	  
	status=BZ2_bzCompress(&outgoing,BZ_FINISH);
    	  
	if(status<0)
      {
      /* An error has ocurred. */
      throw Bzip2CompressException();
      }

    for(int i = 0; i < (int)(BUFFER_SIZE-outgoing.avail_out); i++)
      {
      out.push_back(Buffer[i]);
      }    
    } 
  while (outgoing.avail_out==0);
    
  return out;
  }
    
vector<Uint8> Bzip2Compress::Decode(vector<Uint8> const& data)
  {
  vector<Uint8> out;
  int status;

  Uint8 Buffer[BUFFER_SIZE];

  incoming.next_in=(char *)&data[0];
  incoming.avail_in=data.size();

  do 
    {
	incoming.next_out=(char *)Buffer;
	incoming.avail_out=BUFFER_SIZE;
	  
	status=BZ2_bzDecompress(&incoming);

	if(status<BZ_OK)
      {
      /* An error has ocurred. */
      throw Bzip2DecompressException();
      }

    for(int i = 0; i < (int)(BUFFER_SIZE-incoming.avail_out); i++)
      {
      out.push_back(Buffer[i]);
      }    
    } 
  while(incoming.avail_out==0);

  return out;
  }
