/* $Id: Bzip2Compress.h,v 1.4 2002/04/05 14:00:44 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_BZIP2_H
#define ARIANNE_BZIP2_H

#ifndef _WIN32
// OK, this sucks, but otherwise it will not always compile :-(
#include <stdio.h>
#endif

#include <bzlib.h>
#include <vector>

#include "Types.h"
#include "Exceptions.h"

class Bzip2Compress
  {
  bz_stream incoming;
  bz_stream outgoing;

  void Begin();
  void End();    

  public:
  Bzip2Compress()
    {
    Begin();
    }

  ~Bzip2Compress()
    {
    End();
    }

  std::vector<Uint8> Encode(std::vector<Uint8> const& data);
  std::vector<Uint8> Decode(std::vector<Uint8> const& data);

  class Bzip2Exception: public Exception
    {
    protected:
    Bzip2Exception(): Exception() {}
    };

  class Bzip2CompressException: public Bzip2Exception
    {
    public:
    Bzip2CompressException(std::string const &where = "UNKNOWN"): Bzip2Exception()
      {
      message = where + " - Bzip2 Error Compressing";
      }
    };

  class Bzip2DecompressException: public Bzip2Exception
    {
    public:
    Bzip2DecompressException(std::string const &where = "UNKNOWN"): Bzip2Exception()
      {
      message = where + " - Bzip2 Error Decompressing";
      }
    };
  };

#endif
