/* $Id: StringTool.cpp,v 1.4 2002/03/16 20:43:38 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "StringTool.h"
#include <algorithm>


using namespace std;

/** This method split a string in several strings based on the delimiter. */
vector<string> Split(const string& orig, const string delimiter)
  {
  int x = orig.find(delimiter);
  if ( x == -1 )
    {
    vector<string> retval;
    retval.push_back(orig);
    return( retval );
    }
  string temp = orig.substr(0, x);
  vector<string> retval;
  retval.push_back(temp);
  
  while ( 1 )
    {
    x += delimiter.length() ;
    int y = orig.find(delimiter, x);
    if ( y == -1 )
	  {
  	  break;
	  }
    temp = orig.substr(x, (y-x) );
    x += (y-x);
    retval.push_back(temp);
    }

  temp = orig.substr(x, (orig.length() -1));
  retval.push_back(temp);

  return( retval );
  }

std::string ConvertSpaces2Code(std::string const& text)
  {
  string result;

  bool space_found=false;
  for(string::const_iterator i=text.begin();i!=text.end();++i)
    {
    if((*i==' ') || (*i=='\t'))
      {
      if(!space_found)
        {
        space_found=true;
        result.append("%20");
        }
      }
    else
      {
      space_found=false;
      result+=*i;
      }
    }
  
  return result;
  }

std::string ConvertCode2Spaces(std::string const& text)
  {
  string tmp=text;
  string result;

  int x=tmp.find("%20");

  while(x!=-1)
    {
    result+=tmp.substr(0,x)+" ";
    tmp=tmp.substr(x+3,tmp.size());

    x=tmp.find("%20");
    }
 
  return result+tmp;
  }

bool find_list(std::list<string>::const_iterator begin, std::list<string>::const_iterator end,std::list<string> TextList)
  {
  for(std::list<string>::const_iterator it=TextList.begin();it!=TextList.end();++it)
    {
    std::list<string>::const_iterator found=find(begin,end,*it);
    if(found==end)
      {
      return false;
      }
    }
  
  return true;
  }

bool find_string(std::list<string>::const_iterator begin, std::list<string>::const_iterator end,string TextList)
  {
  std::list<string>::const_iterator found=find(begin,end,TextList);
  if(found==end)
    {
    return false;
    }
  
  return true;
  }
