/* Waba <wabsoft@yahoo.fr> */
/* Note:
 * I haven't done C++ for some time, so I dunno if returning a string is the
 * most efficient way... I suppose so since using new/delete wouldn't be very
 * cool to use.
 * It could be put in a static var, but would fuck up in a multi-threaded 
 * environment.
 * I suppose you'll wipe out the demo parts and the related comments
 */

/* Needed includes */
#include <string>

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef HAVE_CRYPTO
#include <openssl/evp.h>
#endif
/* End of needed includes */

/* Standalone function */
std::string MD5Hash (std::string const &msg)
{
#ifdef HAVE_CRYPTO
	EVP_MD_CTX mdctx;
	unsigned char md_value[EVP_MAX_MD_SIZE];
	unsigned int md_len, i;	
	char *res;
	
	OpenSSL_add_all_digests ();

	// Assign mdctw <-> md5
	EVP_DigestInit (&mdctx, EVP_md5 ());
	// Add msg to the internal thing
	EVP_DigestUpdate (&mdctx, msg.c_str (), msg.length ());
	// Compute the result
	EVP_DigestFinal (&mdctx, md_value, &md_len);

	res = (char *) malloc (md_len*2+1);
	for (i=0; i< md_len; ++i) sprintf (res+i*2, "%02x", md_value[i]);
	res[md_len*2] = 0;;
	
	std::string ret (res);
	free (res);
	
	return (ret);
#else 
	return (std::string (msg));
#endif /* HAVE_OPENSSL */
}

