/* $Id: Rand.cpp,v 1.13 2001/12/23 17:28:39 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2001 by Benjamin Lerman
    email                : quisar@quisar.ambre.net
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef HAVE_CRYPTO

#ifdef HAVE_OPENSSL
#include <openssl/rand.h>
#else
#include <rand.h>
#endif

#include <vector>
#include <string>
#include "Conversion/Conversion.h"
#include "Crypto/Rand.h"

RAND::RAND()
{
}

RAND::RAND(std::vector<unsigned char> const &seed)
{
 RAND_seed(&seed[0], seed.size());
}

RAND::RAND(std::string const &path)
{
 RAND_load_file(path.c_str(), -1);
}

int RAND::load_file(std::string const &path) const
{
 return RAND_load_file(path.c_str(), -1);
}

int RAND::write_file(std::string const &path) const
{
 return RAND_write_file(path.c_str());
}

int RAND::GetRandomBytes(std::vector<unsigned char> &bytes, unsigned int nbbytes) const
{
 bytes.resize(nbbytes);
 if(!RAND_bytes(&bytes[0], nbbytes))
 {
     bytes.resize(0);
     return false;
 }
 return true;
}

int RAND::GetRandomBytes(std::string &bytes, unsigned int nbbytes) const
{
 bytes.resize(nbbytes);
 if(! RAND_bytes((unsigned char *)&bytes[0], nbbytes))
 {
     bytes.resize(0);
     return false;
 }
 return true;
}

int RAND::GetPseudoRandomBytes(std::vector<unsigned char> &bytes, unsigned int nbbytes) const
{
 bytes.resize(nbbytes);
 if(! RAND_pseudo_bytes(&bytes[0], nbbytes))
 {
     bytes.resize(0);
     return false;
 }
 return true;
}

int RAND::GetPseudoRandomBytes(std::string &bytes, unsigned int nbbytes) const
{
 bytes.resize(nbbytes);
 if(! RAND_pseudo_bytes((unsigned char *)&bytes[0], nbbytes))
 {
     bytes.resize(0);
     return false;
 }
 return true;
}

#endif
