/* $Id: Rand.h,v 1.13 2001/12/23 17:28:39 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2001 by Benjamin Lerman
    email                : quisar@quisar.ambre.net
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
 * A class that generate random bytes... On system that do not have        *
 * /dev/random the initialisation is very important... To be taken care.   *
 ***************************************************************************/

#ifndef ARIANNE_crypto_rand_h_
#define ARIANNE_crypto_rand_h_

#include <vector>
#include <string>

class RAND
{
 public:
	RAND();
	RAND(std::vector<unsigned char> const &seed);
	RAND(std::string const &path);
	int load_file(std::string const &path) const;
	int write_file(std::string const &path) const;
	int GetRandomBytes(std::vector<unsigned char> &bytes, unsigned int nbbytes) const;
	int GetRandomBytes(std::string &bytes, unsigned int nbbytes) const;
	int GetPseudoRandomBytes(std::vector<unsigned char> &bytes, unsigned int nbbytes) const;
	int GetPseudoRandomBytes(std::string &bytes, unsigned int nbbytes) const;
};

#endif
