/* $Id: Sha1.h,v 1.13 2001/12/23 17:28:39 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2001 by Benjamin Lerman
    email                : quisar@quisar.ambre.net
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
 * This class implements the SHA-1 hash algorithm. It also allows to crypt *
 * a password with a seed of 10 bytes. (Please note the need for rand for  *
 * this last operation.                                                    *
 ***************************************************************************/

#ifndef ARIANNE_crypto_sha1_h_
#define ARIANNE_crypto_sha1_h_

#include <vector>

#include "Crypto/Rand.h"

class SHA1
{
 public:
	static void GetHash(std::vector<unsigned char> const &m, std::vector<unsigned char> &hash);
	static void GetHash(std::string const &m, std::vector<unsigned char> &hash);
	static void cryptPW(RAND& rand, std::string const& pass, std::string& res);
 	static bool verifyPW(std::string const& pass, std::string const& pwhash);
};

#endif
