/* $Id: AListSerializable.h,v 1.14 2001/12/27 22:31:31 arianne_rpg Exp $ */
#ifndef ARIANNE_RPG_AListSerializable_H
#define ARIANNE_RPG_AListSerializable_H

#include "AList.h"
class Serializer;
#include <iostream>

/** This is a list that can be stored into a vector 

	Please STOP to use it, move instead to std::list.
*/
template <class BaseType>	   
class AListSerializable: public AList<BaseType>
  {
  public:
  AListSerializable(Uint32 size=16): AList<BaseType>(size)
    {
    }

  AListSerializable(AListSerializable const& b): AList<BaseType>(b)
    {
	}

  AListSerializable(AList<BaseType> const& b): AList<BaseType>(b)
    {
	}

  ~AListSerializable()
    {
	}

  /** This store the actual list on a vector */
  void write(Serializer& s) const
    {
    s<<(Uint32)NumCells;

    for(Uint32 i=0;i<NumCells;++i)
      {
      s<<(*(*this)[i]);
      }
    }

  /** This load a list from the Vector */
  void read(Serializer& s)
    {
	Uint32 lsize;
    s>>lsize;

    this->Delete();

    for(Uint32 i=0;i<(Uint32)lsize;++i)
      {
      BaseType *tmp=new BaseType;
      s>>(*tmp);
 
      this->Add(tmp);
      }
    }

  /** This store the actual list on a vector */
  void write(std::ostream& s)
    {
    s<<(Uint32)NumCells << ' ';

    for(Uint32 i=0;i<NumCells;++i)
      {
      s<<(*(*this)[i]) <<' ';
      }
    }

  /** This load a list from the Vector */
  void read(std::istream& s)
    {
	Uint32 lsize;
    s>>lsize;

    this->Delete();

    for(Uint32 i=0;i<(Uint32)lsize;++i)
      {
      BaseType *tmp=new BaseType;
      s>>(*tmp);
 
      this->Add(tmp);
      }
    }
  };

template <class T>
inline std::ostream& operator<<(std::ostream& out, AListSerializable<T> & t)
  {
  t.write(out);
  return out;
  }

template <class T>
inline std::istream& operator>>(std::istream& in,  AListSerializable<T> & t)
  {
  t.read(in);
  return in;
  }

#endif
