/* $Id: InitPath.cpp,v 1.17 2002/03/18 10:13:13 mutable Exp $ */
/***************************************************************************
    copyright            : (C) 2001 by Benjamin Lerman
    email                : quisar@quisar.ambre.net
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "InitPath.h"
#include <fstream>

std::string g_vardir,g_etcdir,g_sharedir,g_logdir,g_libdir;


bool InitPath(std::string const &init_file)
{
    // Note: we don't really read anything here, we just try to open a file
    // for reading which fails if the file doesn't exist.
    std::ifstream test;
#ifdef WIN32
    test.open(init_file.c_str());
    if( test.is_open())
    {
        g_vardir = g_etcdir = g_sharedir = g_logdir = "";
        g_libdir = "Renderers/";
        return true;
    }

#elif defined MACOSX
// TODO: this is a temporary solution. I need to think about the 
// MacOS directory structure, and learn more about bundles before
// I make a solid solution.  However, because of bundles, this should
// be ok. There seems to be a bug here...
    std::string filename = "../Resources/" + init_file;
    test.open(filename.c_str());
    if( test.is_open() )
    {
        g_vardir = "../Resources/";
        g_etcdir = "../Resources/";
        g_sharedir = "../Resources/";
        g_logdir = "../Resources/";
        g_libdir = "../Resources/";
        
        return true;
    }
    
#else
    // try the standard config-file directory first ...
    test.open((ETC_DIR "/" + init_file).c_str());
    if(test.is_open())
    {
        g_vardir = VAR_DIR "/";
        g_etcdir = ETC_DIR "/";
        g_sharedir = SHARE_DIR "/";
        g_logdir = LOG_DIR "/";
        g_libdir = LIB_DIR "/";

        return true;
    }

    // ... then the current directory ...
    test.open(init_file.c_str());
    if(test.is_open())
    {
        g_vardir = g_etcdir = g_sharedir = g_logdir = "";
        g_libdir = "Renderers/";

        return true;
    }

    // ... finally the bin-directory in the source-tree.
    test.open((PACKAGE_SOURCE_DIR "/bin/" + init_file).c_str());
    if(test.is_open())
    {
        g_vardir = g_etcdir = g_sharedir = g_logdir = PACKAGE_SOURCE_DIR "/bin/";
        g_libdir = PACKAGE_SOURCE_DIR "/bin/Renderers/";

        return true;
    }
#endif

    // failure
    return false;
}
