/* $Id: TCPConnection.h,v 1.15 2002/03/17 21:39:28 guidoj Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __ARIANNE_TCPCONNECTION_H
#define __ARIANNE_TCPCONNECTION_H

#include "Connection.h"
#include "SDL_net.h"

class TCPConnectionSet;

/** This is a TCP connection using SDL_net*/
class TCPConnection: public Connection
  {
  IPaddress IP;
  TCPsocket TCP;

  Sint32 Send(const Uint8 *Data,Uint32 size,Uint32 n_elems);
  Sint32 Recv(Uint8 *Data,Uint32 size,Uint32 n_elems);
  Sint32 BlockingSend(const Uint8 *Data,Uint32 size,Uint32 n_elems);
  Sint32 BlockingRecv(Uint8 *Data,Uint32 size,Uint32 n_elems);


  TCPConnection(const TCPConnection& b);
  TCPConnection& operator=(TCPConnection& b);

  public:
  friend class TCPConnectionSet;

  TCPConnection();
  TCPConnection(char *Host, Uint16 Port);
  ~TCPConnection();

  /** Returns the IPaddress in a string */
  std::string GetIPAddress();

  /** This Open the connection to the Host. */
  void Open();
  /** This close the connection to the Host. */
  void Close();
  /** This accept a new connection to the Host. */
  Connection *Accept();

  /** This method check for Data waiting */
  virtual bool isData();
  };

/** This is the TCP implementation of the select call */
class TCPConnectionSet: public ConnectionSet
  {
  public:
  TCPConnectionSet(Uint32 NumConnections=1);
  ~TCPConnectionSet();

  /** This add a connection to the Set */
  void AddConnection(Connection *conn);
  /** This remove a connection to the Set */
  void RemoveConnection(Connection *conn);
  /** This returns true if there is data waiting on the connection */
  bool isData(Connection *conn);
  };

#endif
