/* $Id: Parser.h,v 1.16 2002/04/05 14:00:44 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _ARIANNE_PARSER_H_
#define _ARIANNE_PARSER_H_

#include <string>
#include "Exceptions.h"

//TODO: This code is really fucked. So we have two options: Fix it or remove it.

/** Abstract persistent variable class.*/
class PersistentVar 
  {
  protected:
  std::string filename, blockname, keyname;
  bool dirty;

  /*  Retrive a character string from the ini file in the buffer.
  If key==NULL it returns a double NUL terminated list of keys.
  The default value must never be NULL.
  Section and key names are case insensitive.
  Returns the number of characters placed in the buffer
  */
  int GetIniFileStr(std::string const& section,std::string const& key,std::string const& defval,std::string &buffer,std::string const& inifile);

  /*  Store a character string in the ini file.
  If value==NULL it deletes the entire key.
  If key==NULL it deletes the entire section.
  Returns TRUE is successfull.
  */
  public:
  PersistentVar(void) { dirty=false; };
  virtual ~PersistentVar(){};

  std::string const& FileName() 
    { 
	return filename;
	};

  std::string const& Block() 
    {
	return blockname;
	};

  std::string const& Key() 
    {
	return keyname;
	};

  
  class ParserFileNotFoundException: public Exception
    {
    public:
    ParserFileNotFoundException(std::string const &where = "UNKNOWN"): Exception()
      {
      message = where + " - Error File not Found";
      }
    };
  };


/** A persistent string. */
class PersistentString : public PersistentVar 
  {
  protected:
  std::string value;

  public:
  PersistentString(std::string const& fname,std::string const& block,std::string const& key,std::string const& defvalue = "");
  virtual ~PersistentString(void) {};

  operator const char *(void) 
    {
	return value.c_str(); 
	};

  std::string const& operator= (std::string const& newvalue);
  };

/** A persistent integer. */
class PersistentInt : public PersistentVar 
  {
  protected:
  int value;
  
  public:
  PersistentInt(std::string const&fname, std::string const&block,std::string const&key,int defvalue = 0);
  virtual ~PersistentInt(void) {};

  operator int(void) 
    {
	return value; 
	};

  int operator= (int newvalue);
  };

#endif // __ARIANNE_PARSER_H
