/* $Id: MessageClientManager.h,v 1.2 2002/03/08 12:21:24 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_MessageClientManager_H
#define ARIANNE_MessageClientManager_H

#include "0_Network/NetworkManager.h"
#include "1_Message/MessageManager.h"
#include "Concurrent/Queue.h"

/** This class get GenericMessage from the NetworkManager and store it, it also
    convert Messages to GenericMessage and gives them to the NetworkManager */
class MessageClientManager: public MessageManager
  {
  /** A pointer to access Network Manager. */
  NetworkManager *NetMan;
  /* This is a queue to store all the incomming message from the NetworkManager */
  Queue<Message> incomming;

  public:
  MessageClientManager(NetworkManager *NetMan);
  ~MessageClientManager();

  virtual void loop();

  /** This send a message through the NetworkManager */
  void Add(Message *Mes);
  /** This blocks the caller until a message arrive. */
  Message *Get();
  /** This returns true if there are messages awaiting */
  bool isAvailable() const;
  };

#endif
