/* $Id: Connections.h,v 1.3 2002/04/08 23:54:13 doomster Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_Connections_H
#define ARIANNE_Connections_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Types.h"
#include "Network/TCPConnection.h"
#include "Define.h"

#include <utility>
#include <list>

struct PlayerConnection
  {
  Uint32 id;
  /** The connection itself */
  TCPConnection *conn;
  TCPConnectionSet* connSet;

  /** Time at which the last message was recieved. */
  Uint32 LastMessageTime;
  };

class Connections: public std::list<PlayerConnection>
  { 
  public:
  typedef Uint32 ID;

  private:
  ID max_id;

  struct PlayerConnectionSet
    {
    TCPConnectionSet* connSet;
    Uint16 used_connections;
    };

  std::list<PlayerConnectionSet> m_PlayerConnSetList;
  std::list<Uint32> m_FreeConnectionID;

  /** For the server connection socket */
  TCPConnectionSet sconnSet;
  TCPConnection sconn;
  
  Connection* AcceptPlayer();
  ID AddPlayer(TCPConnection *conn);

  ID GetValidConnectionID();   

  public:
  Connections();
  ~Connections();

  /** This open a connection to the given host and start to recieve messages.*/
  void Open(char const* Host,Uint16 Port);
  /** This close the connection and stop the reception of messages. */
  void Close();

  
  ID AddPlayer();
  void DelPlayer(ID const& b);
  void WaitData();
  bool isMessage(ID const& b);
  bool isData();

  PlayerConnection &find(ID const &b);  


  class ConnectionsException: public Exception
    {
    public:
    ConnectionsException(std::string const &where = "UNKNOWN"): Exception()
      {
      message = where + " - Error no such connection";
      }
    };
  };

#endif
