/* $Id: MessageServerManager.h,v 1.17 2002/03/22 18:31:26 guidoj Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_MessageServerManager_H
#define ARIANNE_MessageServerManager_H

#include "Concurrent/Queue.h"
#include "0_Network/NetworkManager.h"
#include "1_Message/MessageManager.h"
#include "1_Message/Message.h"

/** This class send and recieve message to and from the Network manager */
class MessageServerManager: public LoopThread, public MessageManager
  {
  /** A pointer to access the Network Manager to ask it for Messages and deliver recieve ones. */
  NetworkManager *NetMan;
  /** This is a queue to store all the incomming message from the NetworkManager */
  Queue<Message> incomming;

  /** Stats for the Server Stats */
  TemporalInfoLayer1 StatsL1;

  /** This is useful for knowing when the last message was sent to the StatsManager */
  Uint32 LastTimeStatCommand;
  /** Send the stats to StatManager if time between last stats is greater
      than a given value, or if Mandatory is true, send them inconditionally.
      This method reset the stats. */
  void SentStatL1Command(bool Mandatory=false);

  public:
  MessageServerManager(NetworkManager *NetMan);
  ~MessageServerManager();

  virtual void loop();

  /** This send a message through the NetworkManager */
  void Add(Message *Mes);
  /** This blocks the caller until a message arrive. */
  Message *Get();
  /** This returns true if there are messages awaiting */
  bool isAvailable() const;
  };

#endif
