/* $Id: Bridges.h,v 1.14 2002/03/08 12:21:25 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_Bridges_H
#define ARIANNE_Bridges_H

#include "1_Message/MessageManager.h"
#include "2_Command/CommandManager.h"
#include "2_Command/Command.h"


/** This is a bridge between Message <--> Command level.
    A bridge is a way of interconnection two different parts of the project.
	In this case, we have the Network Layers and the Commands Layers. **/
class Message2CommandBridge: public LoopThread, public Manager
  {
  CommandManager *ComMan;
  MessageManager *MesMan;

  public:
  Message2CommandBridge(CommandManager *ComMan,MessageManager *MesMan);
  virtual ~Message2CommandBridge();

  virtual void loop();
  };

/** This is a bridge between Command <--> Message level.
    A bridge is a way of interconnection two different parts of the project.
	In this case, we have the Network Layers and the Commands Layers. **/
class Command2MessageBridge: public LoopThread, public Manager
  {
  MessageManager *MesMan;

  public:
  Command2MessageBridge(MessageManager *MesMan);
  virtual ~Command2MessageBridge();

  virtual void loop();
  };

#endif
