/* $Id: CommandManager.h,v 1.16 2002/03/08 12:21:25 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_CommandManager_H
#define ARIANNE_CommandManager_H

#include "Concurrent/Thread.h"
#include "2_Command/Command.h"
#include "Manager/Manager.h"
#include "Concurrent/Mutex.h"

#include <list>

/** This class route the command messages to the Managers. */
class CommandManager: public LoopThread , public Manager
  {
  /** A List of Managers subscribed to each type of message. */
  std::list<Manager*> CommandList[NUMBER_OF_COMMANDS];
  Mutex mutex;

  /** Stats for the Server Stats */
  TemporalInfoLayer2 StatsL2;

  /** This is useful for knowing when the last message was sent to the StatsManager */
  Uint32 LastTimeStatCommand;
  /** Send the stats to StatManager if time between last stats is greater 
      than a given value, or if Mandatory is true, send them inconditionally. 
      This method reset the stats. */
  void SentStatL2Command(bool Mandatory=false);

  public:
  CommandManager();
  virtual ~CommandManager();

  /** This subscribes a Manager to a given type of command. So all the commands of that
      type are routed to the manager. */
  bool Subscribe(Manager *Man,Uint8 Type);
  /** This unsubscribes the Manager from the given type of command. */
  bool Unsubscribe(Manager *Man,Uint8 Type);

  virtual void loop();
  };

#endif
