/* $Id: ActionManager.h,v 1.16 2002/03/08 12:21:25 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_ActionManager_H
#define ARIANNE_ActionManager_H

#include "1_Message/Message.h"
#include "Concurrent/Thread.h"

#include "1_Message/MessagesTypes.h"
#include "PlayerConnectionManager.h"
#include "5_Rp/RPManager.h"

/** The task of this Manager is to follow actions from users to RP and 
    from RP to users, it also will join several actions that are for the
    same player to be send on a single message. */
class ActionManager: public Manager, public LoopThread
  {
  /** This verify that the message is of the correct type and follow it to 
      the processor. */
  void MessageAdminType(Message *Mes);
  /** This process the message from a player and sent it to RP. */
  void ActionM(Message_C2S_ACTION *Mes);

  RPManager *rpMan;
  PlayerConnectionManager *playerConMan;

  public:
  ActionManager(PlayerConnectionManager *playerConMan,RPManager *rpMan);
  virtual ~ActionManager() {};

  virtual void loop();
  };

#endif
