/* $Id: L3_Exceptions.h,v 1.2 2002/03/08 12:21:25 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_L3_EXCEPTIONS_H
#define ARIANNE_L3_EXCEPTIONS_H

#include "Exceptions.h"

class ManagerUnCommandException: public Exception
  {
  public:
      ManagerUnCommandException(std::string const& where = "UNKNOWN"): Exception()
      {
	  message = where + " - Error recieving command: Unknown type.";
      }
  };

class ManagerBogusOldMessage: public Exception
{
  public:
      ManagerBogusOldMessage(std::string const& where = "UNKNOWN"): Exception()
      {
	  message = where + " - Error receiving old message on closed connexion.";
      }
};

class ManagerUsedConnectionException: public Exception
  {
  public:
      ManagerUsedConnectionException(std::string const& where = "UNKNOWN"): Exception()
      {
	  message = where + " - Error: Trying to acquire an used connection.";
      }
  };

class ManagerUnUsedConnectionException: public Exception
  {
  public:
      ManagerUnUsedConnectionException(std::string const& where = "UNKNOWN"): Exception()
      {
	  message = where + " - Error: Trying to release an unused connection.";
      }
  };

class FileNotFoundException: public Exception
  {
  public:
      FileNotFoundException(std::string const& where = "UNKNOWN"): Exception()
      {
	  message = where + " - Error: File not found.";
      }
  };

class PlayerNotFoundException: public Exception
  {
  public:
      PlayerNotFoundException(std::string const& where = "UNKNOWN"): Exception()
      {
	  message = where + " - Error: Player not found.";
      }
  }; 

class PlayerAlreadyExistException: public Exception
  {
  public:
      PlayerAlreadyExistException(std::string const& where = "UNKNOWN"): Exception()
      {
	  message = where + " - Error: Player already created.";
      }
  }; 
#endif
