/* $Id: PerceptionManager.h,v 1.16 2002/04/23 19:11:42 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_PerceptionManager_H
#define ARIANNE_PerceptionManager_H

#include "1_Message/Message.h"
#include "Concurrent/Thread.h"

#include "1_Message/MessagesTypes.h"

#include "3_Manager/PlayerConnectionManager.h"

#include "5_Rp/RPManager.h"

/** This is the Manager that build the perceptions and sent it to the client.*/
class PerceptionManager: public Manager, public LoopThread
  {
  PlayerConnectionManager *PlayerConMan;
  RPManager *RPMan;

  /** This method build the perception for all the active players. */
  void PerceptionM();
  /** This will build the Delta perception for the player pID. */
  bool BuildDeltaPerception(Object::ID pID,Message_S2C_PERCEPTION *mes);

  public:
  PerceptionManager(PlayerConnectionManager *PlayerConMan,RPManager *RPMan);
  virtual ~PerceptionManager() {};

  virtual void loop();
  };

#endif
