/* $Id: StatsManager.h,v 1.16 2002/03/08 12:21:25 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_StatsManager_H
#define ARIANNE_StatsManager_H

#include "Manager/Manager.h"
#include "Concurrent/Thread.h"
#include "Log/Log.h"

#include "3_Manager/StatsStructs.h"

/** How often a report file should be created? */
#define REPORT_FILE_GENERATION_TIME 3600

/** This class manage the creation of stats file for Arianne */
class StatsManager: public Manager, public LoopThread
  {
  /* Stats for each Layer/Level. A Layer is for example 0_Network */
  TemporalInfoLayer0 tmpInfL0;
  TemporalInfoLayer1 tmpInfL1;
  TemporalInfoLayer2 tmpInfL2;
  TemporalInfoLayer3 tmpInfL3;
  TemporalInfoLayer4 tmpInfL4;

  PermanentInfo perInf;
  PermanentInfo allTimeperInf;
  ServerInfo serverInf;

  /** Time of the last dump */
  Uint32 LastTimeDump;

  /** Load the All times Permanent stats from disk from file LASTEST. */
  bool LoadStats();
  /** Save the All times Permanent stats to disk to LASTEST. */
  bool SaveStats();
  /** Save the stats to the time name file, one each REPORT_FILE_GENERATION_TIME seconds */
  bool FlushStats();

  /** Write it to a file */
  bool dump(std::string const& Filename);

  public:
  StatsManager();
  virtual ~StatsManager();

  virtual void loop();
  };

#endif
