/* $Id: MiguelRPManager.h,v 1.3 2002/03/08 12:21:25 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_MiguelRPManager_H 
#define ARIANNE_MiguelRPManager_H

#include "RPManager.h"

/** A test RP Manager on C++. No Python Wrapper */
class MiguelRPManager: public RPManager
  {
  RPManager::ActionResult Execute(Action const& action);

  public:
  /** It returns if action is complete and if object is modified. */
  typedef std::pair<RPManager::ActionResult,bool> (*ActionPrototype)(WorldManager &, Object &, Action const&);

  MiguelRPManager(WorldManager *worldMan);
  ~MiguelRPManager();

  void Register(Action::Type const& type, ActionPrototype prototype);
  void Unregister(Action::Type const& type);

  private:
  /** A Map that Link Actions with Methods that process them. */
  std::map<Action::Type, ActionPrototype> m_actionManager;
  };

#endif
