/* $Id: PythonRPManager.h,v 1.3 2002/04/02 23:48:11 mutable Exp $ */
/***************************************************************************
    copyright            : (C) 2002 by Brian Rowe
    email                : briprowe@yahoo.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ARIANNE_PythonRPManager_h_
#define ARIANNE_PythonRPManager_h_

#include <map>
#include <string>
#include <vector>

#include "Python.h"

#include "RPManager.h"
#include "Exceptions.h"
#include "script/PythonLanguage.h"
#include "script/ScriptInterface.h"
//#include "script/RPScript.h"

/** This is a quick prototype of the Script-enabled RPManager that I'm
 *  planning on creating.  It will only be able to do Python right now.
 *  
 *  I'm doing this so people can start working on their Python scripts
 *  that will go into the final Arianne.  
 */

class PythonRPManager : public RPManager
{
 private:  

//  std::map<Action::Type, RPScript> m_Scripts;
  WorldManager *worldman;
  PyObject *arianne;
  PythonLanguage pyth;
  ScriptInterface m_tab;
 
  PyObject *CreatePyPointers(std::vector<void*> ptrs); 
  void BuildScripts(PyObject *scriptList);  // throws PyException

 public:
  PythonRPManager(WorldManager *worldMan);
  ~PythonRPManager();

  RPManager::ActionResult Execute(const Action& action);


};

#endif
