/* $Id: WorldManager.h,v 1.22 2002/04/05 17:00:24 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_WorldManager_H 
#define ARIANNE_WorldManager_H

#include "4_Object/Object.h"
#include "4_Object/World.h"
#include "4_Object/ObjectClassManager.h"

#include "Manager/Manager.h"
#include "Concurrent/Thread.h"
#include "Concurrent/Mutex.h"


/** This class holds the World Manager.*/
class WorldManager: public Manager, public LoopThread
  {
  Object::ID MaxUsedID;

  //TODO: This should have several world inside. Look for Portal concept on Mailing lists.
  World world;

  /** The Object Class Information Container */
  ObjectClassManager m_objectman;

  WorldManager(WorldManager const&b);
  WorldManager &operator=(WorldManager const &b);

  Mutex mutex;

  public:
  WorldManager();
  ~WorldManager();

  void Load();
  void Save();

  /** Get a copy of the object with object id id */
  Object Get(Object::ID const& id);
  /** Add a copy of the object to the world */
  void Add(Object const& object);
  /** Delete an object which id is is */
  void Del(Object::ID const& id);
  /** Delete the object*/
  void Del(Object const& object);


  /** Returns objects in the given cylinder. */
  std::list<Object> isInRange(std::string const& Center,Uint32 Distance);
  std::list<Object> isInRange(Object const& object,Uint32 Distance);

  /** Returns a valid id for a new object */
  Object::ID GetValidID();

  /** Create a new Random object with id=id */
  void CreateRandomPlayer(std::string type,std::string name,Object::ID id);

  virtual void loop();

  class NoWorldFileException: public Exception
    {
    public:
    NoWorldFileException(std::string const& where = "UNKNOWN"): Exception()
      {
      message = where + " - Error: Can't open World file.";
      }
    };
  };

#endif
