/* $Id: Arianneserver.h,v 1.21 2002/04/26 18:15:58 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef ARIANNE_SERVER
#define ARIANNE_SERVER

#include "Log/Logger.h"

#include "0_Network/NetworkServerManager.h"
#include "1_Message/MessageServerManager.h"

#include "2_Command/Bridges.h"

#include "3_Manager/AdminManager.h"
#include "3_Manager/ActionManager.h"
#include "3_Manager/PerceptionManager.h"
#include "3_Manager/StatsManager.h"

#include "4_Object/World.h"

#include "5_Rp/RPManager.h"
#include "5_Rp/PythonRPManager.h"
#include "5_Rp/MiguelRPManager.h"
#include "5_Rp/WorldManager.h"

#include "CommandLineParser.h"

extern Semaphore gWaitPointSemaphore;
extern bool gShutdownRequested;

/** This is a class that encapsulate a server. Something in the Java way.*/
class ArianneServer
  { 
  /** The Network Manager */
  NetworkServerManager NetMan;
  /** The Message Manager */
  MessageServerManager MesMan;

  /** The Command to Message Bridge Manager */
  Command2MessageBridge Comm2Mes;
  /** The Message to Command Bridge Manager */
  Message2CommandBridge Mes2Comm;
  /** The deliverer of Commands: Command Manager */
  CommandManager CommMan;

  /** The Admin Manager for Admin Commands. */
  AdminManager AdminMan;
  /** The PlayerConnection Manager. */
  PlayerConnectionManager PlayerConMan;
  /** The Action Manager for Action Commands. */
  ActionManager ActionMan;
  /** The Perception Manager for creating Perception Commands. */
  PerceptionManager PerceptionMan;
  /** The Statistic Manager for Stats Commands. */
  StatsManager StatsMan;

  /** The world that the server will host. */
  World world;

  /** The World Manager */
  WorldManager WorldMan;
  /** The RP Manager */
  MiguelRPManager RPMan;

  CommandLineParser commandLine;

  public:
  ArianneServer();
  ~ArianneServer();
  /** Init the server */
  void Init();
  /** Run the server */
  void Run(bool ConsoleEnabled);
  /** Close the server */
  void Close();
  };

#endif
