/***************************************************************************
    copyright            : (C) 2002 by Brian Rowe
    email                : briprowe@yahoo.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** This class is the abstract base class that defines all the services that a
    Language must provide to Arianne */
    
class Language
{
  private:
    // not copyable
    Language(const Language &rhs);
    // not assignable
    Language& operator=(Language const&);
  public:
    Language(){}
    virtual ~Language(){}

    virtual void Startup() = 0;
    virtual void Shutdown() = 0;
};
