/***************************************************************************
    copyright            : (C) 2002 by Brian Rowe
    email                : briprowe@yahoo.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string>

/** This class is used to provide an interface between the Languages and
    the rest of the Arianne system. This class will be a singleton. */

class LanguageManager // Should this inherit from Manager ??
{
 private:

 public:
  LanguageManager();
  LanguageManager(const LanguangeManager &rhs);

  ~LanguageManager();

  /* This takes a filename for the Languages configuration file, and returns
     0 for failure, or the number of Languages loaded */
  int Startup(const string &filename);

  /** This returns 0 for failure, or non-zero for success */
  int Shutdown();

};
