/***************************************************************************
    copyright            : (C) 2002 by Brian Rowe
    email                : briprowe@yahoo.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string>

/** This is the abstract base class for all scripts of any language. */

class Script
{
 private:

 public:
  Script();
  Script(const Script &rhs);

  virtual ~Script();

  /** This returns true for success and false for failure */
  virtual bool Startup() = 0;
  /**  This takes the name of the source file as a parameter */
  virtual bool Startup(const std::string &filename) = 0;

  /** Returns true for success, and false for failure */
  virtual bool Shutdown() = 0;

  /** All scripts must be able to communicate via text */
  virtual std::string Execute(const std::string &params) = 0;
};
