/* $Id: ScriptInterface.h,v 1.4 2002/04/24 09:17:48 arianne_rpg Exp $ */
/***************************************************************************
    copyright            : (C) 2002 by Brian Rowe
    email                : briprowe@yahoo.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __ScriptInterface_h_
#define __ScriptInterface_h_

#include "Python.h"

// Added include prefixes -waba
#include "Py2Attributes.h"
#include "5_Rp/WorldManager.h"


/** These functions are for interfacing with the Python interpreter */
PyObject* PyGetObject(PyObject* args);
PyObject* PyAdd(PyObject* args);
void      PyDel(PyObject* args);
PyObject* PyisInRange(PyObject *args);
PyObject* PyGetValidID();


class ScriptInterface
{
 private:
  WorldManager *worldman;

  /** These functions make the actual call into the server */
  Object GetOb(Object::ID const& id);
  void AddOb(Object const& object);
  void DelOb(Object::ID const& id);
  void DelOb(Object const& object);
  std::list<Object> isInRangeOb(std::string const& Center, Uint32 Distance);
  std::list<Object> isInRangeOb(Object const& object, Uint32 Distance);
  Object::ID GetValidIDOb();
  
 public:
  ScriptInterface(WorldManager *wptr);
  ScriptInterface(const ScriptInterface& rhs);

  ~ScriptInterface();

  std::vector<void*> GetPyPointers();

  /** These are the Python interface functions */
  friend PyObject* PyGetObject(PyObject* args);
  friend PyObject* PyAdd(PyObject* args);
  friend void      PyDel(PyObject* args);
  friend PyObject* PyisInRange(PyObject *args);
  friend PyObject* PyGetValidID();
};

#endif
