#include <iostream>
#include "../PythonLanguage.h"
#include "../Py2Attributes.h"
#include "4_Object/Attributes.h"

using namespace std;

int main(int argc, char **argv)
{
 
  cout << "Starting Python" << endl;

  PythonLanguage pyth;
  Attributes att;
  att.PutAttrib("name", "brian");
  att.PutAttrib("age", "22");
  
  try
  {
  pyth.AddPath(".");

  Py2Attributes pyob(att);
  PyObject *object = pyob.GetPython();
 // PyObject *keys = PyList_New(2);
  PyObject *keys = PyDict_Keys(object);
  std::string key1 = PyString_AsString(PyList_GetItem(keys, 0));
  std::string key2 = PyString_AsString(PyList_GetItem(keys, 1));

  std::string val1 = PyString_AsString(PyDict_GetItemString(object,
                                        const_cast<char*>(key1.c_str())));
  std::string val2 = PyString_AsString(PyDict_GetItemString(object,
                                        const_cast<char*>(key2.c_str())));

  std::cout << key1 << " = " << val1 << std::endl;
  std::cout << key2 << " = " << val2 << std::endl;

  Py2Attributes fromPy2C(object);
  
  std::cout << "Now testing how it works going from Python to c++" << std::endl;
  
  std::list<std::string> cKeys = fromPy2C.ListAttribs();
  std::list<std::string>::iterator it;
  for( it = cKeys.begin(); it != cKeys.end(); it++ )
    {
      std::cout << "Key: " << *it << " Value: " << fromPy2C[*it] << std::endl;
    }
  
  std::cout << "fromPy2c == att; Value: ";
  if ( fromPy2C == att )
    {
      std::cout << "true" << endl;
    }
  else
    {
      std::cout << "false" << endl;
    }
  
  std::cout << "att == fromPy2C; Value: ";
  if ( att == fromPy2C )
    {
      std::cout << "true" << endl;
    }
  else
    {
      std::cout << "false" << endl;
    }
    
  Py2Attributes empty;
  std::cout << "fromPy2C == empty; Value: ";
  if ( fromPy2C == empty )
    {
      std::cout << "true" << endl;
    }
  else
    {
      std::cout << "false" << endl;
    }

  std::cout << "att == empty; Value: ";
  if ( att == empty )
    {
      std::cout << "true" << endl;
    }
  else
    {
      std::cout << "false" << endl;
    }
    
  }
  catch(...)
  { std::cout << "Error!" << std::endl; }
  
  return(0);

}
