/* $Id: testRP.cpp,v 1.4 2002/04/05 23:38:54 mutable Exp $ */
/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "5_RP/WorldManager.h"
#include "5_RP/PythonRPManager.h"
#include "Log/Log.h"
#include "InitPath.h"


std::list<Action> ActionToTest(Object::ID const& source)
  {
  std::list<Action> actions;
 
  Action tmp;
  tmp.PutAttrib("type","chat");
  tmp.PutAttrib("source",source);
  tmp.PutAttrib("content","Hi, This is the first Arianne ALPHA 2 Action Message");
  actions.push_back(tmp);

  Action tmp1;
  tmp1.PutAttrib("type","move");
  tmp1.PutAttrib("source",source);
  tmp1.PutAttrib("destination","167 141 0");
  actions.push_back(tmp1);

  Action tmp2;
  tmp2.PutAttrib("type","get");
  tmp2.PutAttrib("source",source);
  tmp2.PutAttrib("slot","r_hand");
  tmp2.PutAttrib("objectID","5");
  actions.push_back(tmp2);

  Action tmp3;
  tmp3.PutAttrib("type","move");
  tmp3.PutAttrib("source",source);
  tmp3.PutAttrib("destination","67 41 0");
  actions.push_back(tmp3);

  Action tmp4;
  tmp4.PutAttrib("type","put");
  tmp4.PutAttrib("source",source);
  tmp4.PutAttrib("slot","r_hand");
  actions.push_back(tmp4);

  return actions;
  }

int main(int num, char** argc)
  {
  Log::toFile("TestRP.txt",true);

#ifdef MACOSX
  g_sharedir="../Resources/";
  g_libdir="../Resources/";
#endif

  WorldManager worldMan;
  worldMan.Load();

  Object ob, ob2;
  ob.PutAttrib("position", "0 0 0");
  ob.PutAttrib("id", "6");	
  ob2.PutAttrib("position", "167 141 0");
  ob2.PutAttrib("id", "5");
  
  worldMan.Add(ob);
  worldMan.Add(ob2);
  
  PythonRPManager rpMan(&worldMan);

  rpMan.Add(ActionToTest("6"));
  int i=0;
  while(i<60)
    {
    rpMan.loop();
    i++;
    }

  worldMan.Save();

  return 0;
  }
