/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
     This program should convert from a height map in ascii format to the map
     format that we are going to use on the game.
***************************************************************************/

#include <string>
#include <iostream>
#include <ctime>
#include <cstdio>

#include "Types.h"

#include "5_Rp/WorldManager.h"
#include "InitPath.h"

using namespace std;

int main(int Num,char **arg)
  {
  //TODO: Check for XML file too
  if(!InitPath("Server.ini"))
    {
    cerr << "Error: Unable to find Server.ini." << endl;
	exit(1);
    }
      
  if(Num<3)
    {
    cout << "USAGE: ascii2map SideSizeInTiles MetersBetweenCells NameAsciiMap" << endl;
    return 0;
    }
  
  Uint16 Side=atoi(arg[1]);
  // Uint16 PieceSide=atoi(arg[2]);

  Uint32 HeightMap;

  std::string FileName=arg[3];

  /* Now we try to open the heigth map file */
  FILE *Handle=fopen(arg[3],"rb");
  if(Handle==NULL)
    {
    cout << "ERROR: Unable to open file " << arg[3] << endl;
    return 0;
    }

  WorldManager world;

  cout << "Creating new terrain:" << endl;
  Uint32 lasttime=time(0);

  for(int i=0;i<(int)(Side*Side);++i)
    {
    fscanf(Handle,"%i",&HeightMap);
    if(HeightMap<0) HeightMap=0;

    //TODO: Fix this to work using the new Object System.
    Object tmp;

    /*    
    tmp->m_id=1024+i;
	tmp->m_type=0;

	tmp->m_pos.m_x=(i/Side)*PieceSide*10;
	tmp->m_pos.m_y=(i%Side)*PieceSide*10;
	tmp->m_pos.m_z=HeightMap;
	
    tmp->m_orie.m_yaw=0;
	tmp->m_orie.m_roll=0;
	tmp->m_orie.m_pitch=0;

	tmp->m_gfx.m_baseType=0;
	tmp->m_gfx.m_damageMod=0;
	tmp->m_gfx.m_modificator=0;

	tmp->m_vol.m_a=PieceSide*10;
	tmp->m_vol.m_b=PieceSide*10;
    */

    world.Add(tmp);

    if(i%256==0) putc('.',stdout);
    }
  fclose(Handle);

  cout << "\n-DONE-   TIME: " << (float)(time(0)-lasttime) << endl;
  lasttime=time(0);


  cout << "Saving the terrain: " << endl;

  world.Save();
  
  cout << "-DONE-   TIME: " << (float)(time(0)-lasttime) << endl;
  lasttime=time(0);

  return 0;
  }

